

-- LilSparky's Lab Partner -- Addon for WOW Crafting
-- Lilsparky of Lothar
-- v0.11
-- mar.06.2008


LSLP_VERSION = "LSLP v0.10";
LSLP_VERSION_LONG = "LilSparky's Lab Partner v0.10"


LSLP_PopupFrame = nil;
LSLP_FocusLink = nil;


function LSLP_ChatMessage(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cff80d060"..(msg or "nil"));
end

function LSLP_ErrorMessage(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..(msg or "nil"));
end


function LSLP_UpdateFilter(link)
	if ( not link) then return end
	
	local itemName, _, _, _, _, _, _, _, loc = GetItemInfo(link);
	
	local locname = LSLP_ItemLocationNames[loc];
	
	local searchname = locname;
	
	if (locname == "") then
		if (LSLP_SpecialCases[itemName]) then
			searchname = LSLP_SpecialCases[itemName];
		end
	end

--	LSLP_ChatMessage("item "..itemName.."  search "..searchname);


	if (Skillet and Skillet:IsCraft() and Skillet.currentTrade) then
		local box = getglobal("SkilletFilterBox");
		box:SetText(searchname);
		Skillet.UpdateFilter(Skillet,searchname)
	elseif (ATSWFrame and ATSWFrame:IsVisible() and atsw_oldmode) then
		local box = getglobal("ATSWFilterBox");
		
		box:SetText(searchname);
		ATSW_UpdateFilter(searchname);
	elseif (CraftFrame and CraftFrame:IsVisible()) then
		local box = getglobal("CraftFrameEditBox");
		
		box:SetText(searchname);
		CraftFrame_Update();
	end
	
	if (TradeskillInfoUI and TradeskillInfoFrame:IsVisible()) then
		local box = getglobal("TradeskillInfoSearchButton");
		box:SetText(searchname);
		
		TradeskillInfoUI.SetSearchText(TradeskillInfoUI,searchname);
		
		local reagentbutton = TradeskillInfoUI.options.buttons["TradeskillInfoReagentButton"].var
		local namebutton = TradeskillInfoUI.options.buttons["TradeskillInfoNameButton"].var
		
		TradeskillInfoUI.db.profile[reagentbutton] = false;
		TradeskillInfoUI.db.profile[namebutton] = true;
		
		TradeskillInfoUI.Search_OnClick(TradeskillInfoUI);
	end
end


function LSLP_HandleModifiedItemClick(link)
--	if ( IsControlKeyDown()) then
	if ( IsAltKeyDown()) then
		local button = GetMouseButtonClicked();
		
		if (button == "RightButton") then
			LSLP_UpdateFilter(link);
			LSLP_EnchantPopup_Show(link);
		else
			LSLP_UpdateFilter(link);
		end
		return true;
	end
	return HandleModifiedItemClick_ORIGINAL(link);
end


function LSLP_PopupFrame_Enchant(index, expectedName)
	local name = GetCraftInfo(index);
	
	if (name ~= expectedName) then
		LSLP_ErrorMessage("Expected to cast "..expectedName.." but somehow was told to cast "..name..".  Doing nothing.");
	else
		DoCraft(index);
	end
end


function LSLP_PopupFrame_Init(level)
--LSLP_ChatMessage("LSLP_PopupFrame_Init "..(level or "nil"))
	if (level == 1) then
		local itemName, _, _, _, _, _, _, _, loc = GetItemInfo(LSLP_FocusLink);
		local locname = LSLP_ItemLocationNames[loc];

		local searchname = locname;
	
		if (loc == "") then
			if (LSLP_SpecialCases[itemName]) then
				searchname = LSLP_SpecialCases[itemName];
			
--				LSLP_ChatMessage("item "..itemName.."  search "..searchname);
			end
		end
	
--		SetCraftItemNameFilter(searchname);
		SetCraftItemNameFilter("");
	
		local title = {};
		local info = {};
	
		title.text = itemName;
		title.isTitle = true;
		title.textHeight = 14;
	
		local _, _, quality, _, _, itemLevel = GetItemInfo(LSLP_FocusLink);	
			
		if (quality) then
			title.textR, title.textG, title.textB  = GetItemQualityColor(quality);
		end
	
		UIDropDownMenu_AddButton(title);
	
		info.func = LSLP_PopupFrame_Enchant;
	
		local i,buttonsAdded;
		local numSkills = GetNumCrafts();
		
		if (searchname == "") then numSkills = 0; end
		
		buttonsAdded = 0;
		
		for i=1, numSkills, 1 do
			local name, _, _, num = GetCraftInfo(i);
			
			
			if (string.find(name, searchname)) then
				info.text = name;		
				info.hasArrow = true;
				info.value = GetCraftDescription(i);
				info.arg1 = i;
				info.arg2 = name;
				
				if (num > 0) then
					info.textR, info.textG, info.textB = 1,1,1;
				else
					info.textR, info.textG, info.textB = .6,.6,.6;
				end
			
				UIDropDownMenu_AddButton(info);
				buttonsAdded = buttonsAdded + 1;
			end
		end
	
		if (buttonsAdded == 0) then
			info.text = "No enchants available";
			info.disabled = true;
		
			info.arg1 = "";
			info.arg2 = "";
			info.func = nil;
		
			UIDropDownMenu_AddButton(info, level);
		end
		
		SetCraftItemNameFilter("");
	end
	
	if (level == 2) then
		local button = {}
		local width;
		local s, olds;
		local tip = UIDROPDOWNMENU_MENU_VALUE;
		local tipLength = string.len(tip);
		local lastLine = false;
		
		olds = 0;
			
		while (lastLine == false) do
			s = string.find(tip, " ", olds+50);
		
			if (not s) then
				s = tipLength+1;
				lastLine = true;
			end
		
			button.isTitle = true;
			button.text = string.sub(tip, olds, s-1);
		
			olds = s+1;
			UIDropDownMenu_AddButton(button, level);
		end	
	end
end


function LSLP_EnchantPopup_Show(link)
	if (not GetCraftDisplaySkillLine()) then
		enchantingClosed = true;
		CastSpellByName("Enchanting");
	end
		
	GameTooltip:Hide();
	LSLP_FocusLink = link;
	UIDropDownMenu_Initialize(LSLP_PopupFrame, LSLP_PopupFrame_Init, "MENU");
	ToggleDropDownMenu(1, nil, LSLP_PopupFrame, this, this:GetWidth(), 0);

--	if (enchantingClosed) then
--		CloseCraft();
--	end
end



function LSLP_init()
--LSLP_ChatMessage("initialize");
	LSLP_PopupFrame = CreateFrame("Frame", "LSLP_PopupFrame", getglobal("UIParent"), "UIDropDownMenuTemplate");

	HandleModifiedItemClick_ORIGINAL = HandleModifiedItemClick;
	
	HandleModifiedItemClick = LSLP_HandleModifiedItemClick;
	
	local doNotTradeButton = getglobal("TradeRecipientItem7ItemButton");
	
	if doNotTradeButton then
		doNotTradeButton:RegisterForClicks("LeftButtonUp","RightButtonUp");
	else
		LSLP_ErrorMessage("Could not register the do not trade button for clicks.")
	end
end



LSLP_init()




